## kmymoney 5.1.2

=== CMakeLists.txt ===
# The CMake version we require
cmake_minimum_required(VERSION 3.12)

set(RELEASE_SERVICE_VERSION_MAJOR "5")
set(RELEASE_SERVICE_VERSION_MINOR "1")
set(RELEASE_SERVICE_VERSION_MICRO "2")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# Setting the name of the main project
project(KMyMoney VERSION "${RELEASE_SERVICE_VERSION}" LANGUAGES CXX)

# Determine the GIT reference (if we're based on GIT)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND git rev-parse --short HEAD WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" OUTPUT_VARIABLE VERSION_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
  # Add variables which are similar to the build in names of cmake
  set(PROJECT_VERSION_SUFFIX "${VERSION_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "${VERSION_SUFFIX}")
elseif(DEFINED VERSION_SUFFIX)
  string(REGEX REPLACE "-*(.+)" "\\1" DASHFREE_SUFFIX "${VERSION_SUFFIX}")
  set(PROJECT_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
endif()

# Automoc all sources
set(CMAKE_AUTOMOC TRUE)
list(APPEND CMAKE_AUTOMOC_MACRO_NAMES "K_PLUGIN_FACTORY" "K_PLUGIN_FACTORY_WITH_JSON")

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW) # Policy introduced in CMake version 3.3
endif()
if (POLICY CMP0071)
  # We do not require the old behaviour. It is only set to old, to prevent accidential use of
  # the new behavour. If the new behaviour becomes important, cmake_minimum_required has to be
  # set to "3.10".
  cmake_policy(SET CMP0071 OLD) # Policy introduced in CMake version 3.10
endif()


######################### General Requirements ##########################

if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0)
    message(FATAL_ERROR "This version of KMyMoney requires at least gcc 6.0.0 to be built successfully")
endif()

set(APPLE_SUPPRESS_X11_WARNING TRUE)
find_package(ECM 5.42 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(KDEInstallDirs)
include(KDECMakeSettings)
# reimplementation because kmymoney app image is bound to ECM 5.36
if("${ECM_GLOBAL_FIND_VERSION}" VERSION_LESS "5.38.0")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
  if(WIN32)
     set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
  else()
     set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
  endif()
elseif(NOT WIN32)
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
endif()

include(FeatureSummary)
include(CMakeDependentOption)

include(GenerateExportHeader)
include(KMyMoneyMacros)

find_package(PkgConfig)

set (OPT_KF5_COMPONENTS DocTools Holidays Contacts Akonadi IdentityManagement Activities)
find_package(Gpgmepp)
if (Gpgmepp_FOUND)
  set(GPG_FOUND TRUE)
else()
  set(GPG_FOUND FALSE)
  list(APPEND OPT_KF5_COMPONENTS Gpgmepp)
endif()

if (PkgConfig_FOUND)
  pkg_check_modules(SQLCIPHER sqlcipher IMPORTED_TARGET)
  pkg_check_modules(LIBOFX libofx IMPORTED_TARGET)
endif()

find_package(Qt5 5.6 REQUIRED COMPONENTS
  Core DBus Widgets Svg Xml Test PrintSupport)
find_package(Qt5 5.6 OPTIONAL_COMPONENTS
  Sql Concurrent QuickWidgets)

find_package(KF5 5.2 REQUIRED COMPONENTS
  Archive CoreAddons Config ConfigWidgets I18n Completion KCMUtils ItemModels ItemViews Service Wallet IconThemes XmlGui TextWidgets Notifications KIO)
find_package(KF5 5.2 OPTIONAL_COMPONENTS
  ${OPT_KF5_COMPONENTS})


if(LibAlkimia5_DIR)
  set(_LibAlkimia5_DIR ${LibAlkimia5_DIR})
endif()
find_package(LibAlkimia5 8.0)
if (NOT LibAlkimia5_FOUND)
  # restore LibAlkimia5_DIR set to NOTFOUND by first find_package call
  if(_LibAlkimia5_DIR)
    set(LibAlkimia5_DIR ${_LibAlkimia5_DIR})
  endif()
  find_package(LibAlkimia5 7.0 REQUIRED)
endif()

# Recent changes to LibAlkimia should allow us to remove this construct
#if(CMAKE_SYSTEM_NAME MATCHES "Windows")
#  include_directories(${GMP_INCLUDE_DIR})
#endif()

find_package(KChart 2.6.0)

if(KF5Gpgmepp_FOUND)
  set(GPG_FOUND TRUE)
endif()

cmake_dependent_option(ENABLE_GPG "Enable GPG support." ON
                       "GPG_FOUND" OFF)

add_feature_info("Encryption" ENABLE_GPG "Allows to store your financial data using strong GPG encryption.")

add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# use DBus only on Linux
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(KMM_DBUS 1)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

# check for Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

  make_directory("${APIDOC_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kmymoney.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen IMMEDIATE)

  add_custom_target(apidoc "${DOXYGEN}" "${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen")
endif(DOXYGEN_FOUND)
add_feature_info("Doxygen" DOXYGEN_FOUND "Generate API documentation with Doxygen (for devs only).")

# check some include files exists
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=500 -D_BSD_SOURCE)
include (CheckIncludeFileCXX)
check_include_file_cxx("unistd.h" HAVE_UNISTD_H)
check_include_file_cxx("pwd.h" HAVE_PWD_H)
check_include_file_cxx("windows.h" HAVE_WINDOWS_H)
check_include_file_cxx("lmcons.h" HAVE_LMCONS_H)
check_include_file_cxx("process.h" HAVE_PROCESS_H)

# include check for members in structs
include (CheckStructHasMember)

######################### Special Requirements ##########################

# This is needed for QtSqlite and QtDesigner
# (they'll install files to ${QT_INSTALL_DIR}/plugins/)
get_filename_component(QT_BIN_DIR "${QT_MOC_EXECUTABLE}" PATH)
get_filename_component(QT_DIR     ${QT_BIN_DIR}        PATH)
set(QT_INSTALL_DIR ${QT_DIR} CACHE PATH
  "Qt install prefix defaults to the Qt prefix: ${QT_DIR}")

cmake_dependent_option(ENABLE_ADDRESSBOOK "Enable addressbook support." ON
                       "KF5IdentityManagement_FOUND;KF5Akonadi_FOUND;KF5Contacts_FOUND" OFF)

add_feature_info("Address book" ENABLE_ADDRESSBOOK "Allows fetching payee information from KDE PIM system.")

cmake_dependent_option(ENABLE_HOLIDAYS "Enable addressbook support." ON
                       "KF5Holidays_FOUND" OFF)

add_feature_info("Holidays" ENABLE_HOLIDAYS "Allows fetching holidays from KDE PIM system.")

cmake_dependent_option(ENABLE_ACTIVITIES "Enable activities support." ON
                       "KF5Activities_FOUND" OFF)

option(ENABLE_FORECASTVIEW "Enable forecast view" ON)
add_feature_info("Forecast view" ENABLE_FORECASTVIEW "Adds possibility to calculate forecasts.")
cmake_dependent_option(ENABLE_REPORTSVIEW "Enable reports view." ON
                       "KChart_FOUND" OFF)
add_feature_info("Reports view" ENABLE_REPORTSVIEW "Adds possibility to display chart and table reports.")
option(ENABLE_BUDGETVIEW "Enable budget view" ON)
add_feature_info("Budget view" ENABLE_BUDGETVIEW "Adds possibility to plan a budget.")
option(ENABLE_ONLINEJOBOUTBOXVIEW "Enable online job outbox view" ON)
add_feature_info("Online job outbox view" ENABLE_ONLINEJOBOUTBOXVIEW "Adds outbox for sending online jobs.")

cmake_dependent_option(ENABLE_SQLSTORAGE "Enable SQL storage support." ON
                       "Qt5Sql_FOUND" OFF)

add_feature_info("SQL Storage" ENABLE_SQLSTORAGE "Allows storing your financial data in SQL database.")

cmake_dependent_option(ENABLE_SQLCIPHER "Enable SQLCipher support." ON
                       "SQLCIPHER_FOUND" OFF)

# Otherwise compilers halt on something like that:
# ld: library not found for -lsqlcipher
# on MS Windows, FreeBSD, macOS, and Ubuntu 14.04 (Ubuntu has CMake 3.5.1 but I'm not sure if it's the one to blame).
if(ENABLE_SQLCIPHER AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_VERSION VERSION_LESS 3.5.2))
  link_directories(${SQLCIPHER_LIBRARY_DIRS})
endif()

add_feature_info("SQLCipher" ENABLE_SQLCIPHER "Allows encrypting your SQLite3 database.")

cmake_dependent_option(ENABLE_IBANBICDATA "Enable IBAN/BIC data support." OFF
                       "Qt5Sql_FOUND" OFF)

add_feature_info("IBAN/BIC data" ENABLE_IBANBICDATA "Adds predefined IBAN/BIC numbers to KMyMoney (note: doesn't work yet).")

# check for optional QWebEngine
option(ENABLE_WEBENGINE "Enable QWebEngine" OFF)
if(ENABLE_WEBENGINE)
  find_package(Qt5WebEngineWidgets 5.8 REQUIRED)
  if(Qt5WebEngineWidgets_VERSION VERSION_GREATER 5.8.99 AND Qt5WebEngineWidgets_VERSION VERSION_LESS 5.9.3)
    message(WARNING "QWebEngine version ${Qt5WebEngineWidgets_VERSION} is known to be unstable with KMyMoney")
  endif()
else(ENABLE_WEBENGINE)
  find_package(KF5WebKit REQUIRED)
endif(ENABLE_WEBENGINE)

# check for optional LibOFX support
cmake_dependent_option(ENABLE_OFXIMPORTER "Enable OFX Importer" ON
                       "LIBOFX_FOUND" OFF)

if(ENABLE_OFXIMPORTER)
  if(NOT LIBOFX_HAVE_CLIENTUID)
    get_target_property(PATH_TO_LIBOFX_HEADER PkgConfig::LIBOFX INTERFACE_INCLUDE_DIRECTORIES )
    if ("${PATH_TO_LIBOFX_HEADER}" STREQUAL "PATH_TO_LIBOFX_HEADER-NOTFOUND")
      set(PATH_TO_LIBOFX_HEADER ${LIBOFX_INCLUDEDIR})
    endif()
    set(PATH_TO_LIBOFX_HEADER "${PATH_TO_LIBOFX_HEADER}/libofx/libofx.h")
    unset(LIBOFX_HAVE_CLIENTUID)
    unset(LIBOFX_HAVE_CLIENTUID CACHE) #not doing this will prevent updating below check
    check_struct_has_member("struct OfxFiLogin" clientuid ${PATH_TO_LIBOFX_HEADER} LIBOFX_HAVE_CLIENTUID LANGUAGE CXX)
  endif()

  if (LIBOFX_HAVE_CLIENTUID)
    set (nice_LIBOFX_HAVE_CLIENTUID "yes")
  else()
    set (nice_LIBOFX_HAVE_CLIENTUID "no")
  endif()

else()
  set (nice_LIBOFX_HAVE_CLIENTUID "unknown")
  unset(LIBOFX_HAVE_CLIENTUID)
  unset(LIBOFX_HAVE_CLIENTUID CACHE)
endif(ENABLE_OFXIMPORTER)

add_feature_info("OFX Importer" ENABLE_OFXIMPORTER "Allows importing OFX files (have client uid version: ${nice_LIBOFX_HAVE_CLIENTUID})" )

# check for optional KBanking support
find_package(aqbanking 6.0.1)
find_package(gwenhywfar 5.1.2)
find_package(gwengui-cpp)
find_package(gwengui-qt5)

cmake_dependent_option(ENABLE_KBANKING "Enable KBanking plugin" ON
                       "AQBANKING_FOUND;gwengui-cpp_FOUND;gwengui-qt5_FOUND;Qt5QuickWidgets_FOUND" OFF)

add_feature_info(KBanking ENABLE_KBANKING "Interface for the following online banking protocols: HBCI, EBICS, OFX Direct Connect, Paypal")

# check for optional Weboob support
find_package (Python3 COMPONENTS Interpreter Development)

cmake_dependent_option(ENABLE_WEBOOB "Enable Weboob plugin" ON
                       "Python3_FOUND;Qt5Concurrent_FOUND" OFF)
add_feature_info(Weboob ENABLE_WEBOOB "Online banking interface using Weboob.")


# check for optional ical support
find_package(LibIcal)
cmake_dependent_option(ENABLE_LIBICAL "Enable Calendar plugin" ON
                       "LibIcal_FOUND" OFF)
add_feature_info(iCalendar ENABLE_LIBICAL "iCalendar integration.")


option(ENABLE_QIFIMPORTER "Enable QIF Importer" ON)
option(ENABLE_QIFEXPORTER "Enable QIF Exporter" ON)
add_feature_info("QIF Importer" ENABLE_QIFIMPORTER "Allows importing QIF files.")
add_feature_info("QIF Exporter" ENABLE_QIFEXPORTER "Allows exporting QIF files.")

option(ENABLE_GNCIMPORTER "Enable GNC Importer" ON)
add_feature_info("GNC Importer" ENABLE_GNCIMPORTER "Allows importing GNUCash files.")

option(ENABLE_CSVIMPORTER "Enable CSV Importer" ON)
option(ENABLE_CSVEXPORTER "Enable CSV Exporter" ON)
add_feature_info("CSV Importer" ENABLE_CSVIMPORTER "Allows importing CSV files.")
add_feature_info("CSV Exporter" ENABLE_CSVEXPORTER "Allows exporting CSV files.")

option(ENABLE_UNFINISHEDFEATURES "For devs only" OFF)
add_feature_info("New features" ENABLE_CSVEXPORTER "Compiles unfinished features for testing.")

=== kmymoney/plugins/CMakeLists.txt ===
add_subdirectory( onlinetasks )
add_subdirectory( interfaces )
add_subdirectory( csv )
add_subdirectory( qif )
add_subdirectory( gnc )
add_subdirectory( ofx )
add_subdirectory( icalendar )
add_subdirectory( reconciliationreport )
add_subdirectory( checkprinting )
add_subdirectory( views )
add_subdirectory( xml )
add_subdirectory( xmlhelper )

if(ENABLE_SQLSTORAGE)
  add_subdirectory(sql)
endif()

if(ENABLE_IBANBICDATA)
  add_subdirectory(ibanbicdata)
endif()

if (ENABLE_KBANKING)
  add_subdirectory( kbanking )
endif (ENABLE_KBANKING)

if (ENABLE_SQLCIPHER)
  add_subdirectory(sqlcipher)
endif()

option(ENABLE_ONLINEJOBPLUGINMOCKUP "Enable onlineJob-plugin mockup (only for developers)" OFF)
if (ENABLE_ONLINEJOBPLUGINMOCKUP)
  add_subdirectory(onlinejobpluginmockup)
endif()

if (ENABLE_WEBOOB)
  add_subdirectory( weboob )
endif ()

########### next target ###############

set(kmm_plugin_LIB_SRCS
  appinterface.cpp
  importinterface.cpp
  kmymoneyplugin.cpp
  statementinterface.cpp
  viewinterface.cpp
  onlinepluginextended.cpp
  interfaceloader.cpp
)

set(plugin_HEADERS
  appinterface.h
  importinterface.h
  kmymoneyplugin.h
  statementinterface.h
  viewinterface.h
  ${CMAKE_CURRENT_BINARY_DIR}/kmm_plugin_export.h
  onlinepluginextended.h
)

add_library(kmm_plugin SHARED ${kmm_plugin_LIB_SRCS})
generate_export_header(kmm_plugin BASE_NAME kmm_plugin)
target_link_libraries(kmm_plugin
  PUBLIC
    Qt5::Core
    KF5::XmlGui
  PRIVATE
    KF5::KCMUtils
    KF5::KIOWidgets
    Qt5::Gui
    Qt5::Widgets
  INTERFACE
    kmm_mymoney
)

set_target_properties(kmm_plugin PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

########### install files ###############

install(TARGETS kmm_plugin
  ${INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES ${plugin_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney  COMPONENT Devel)

=== kmymoney/widgets/CMakeLists.txt ===

########### create links ###############
set(kmymoney_STAT_HEADERS
  kaccounttemplateselector.h kguiutils.h
  kmymoneyaccountcombo.h kmymoneyaccountcompletion.h
  kmymoneyaccountselector.h
  kmymoneycategory.h
  kmymoneycombo.h kmymoneymvccombo.h kmymoneycompletion.h
  kmymoneycurrencyselector.h  kmymoneydateinput.h
  kmymoneylineedit.h kmymoneyselector.h
  kmymoneytitlelabel.h register.h registeritem.h groupmarker.h fancydategroupmarker.h
  scheduledtransaction.h selectedtransaction.h selectedtransactions.h stdtransactiondownloaded.h
  stdtransactionmatched.h transactioneditorcontainer.h
  transactionform.h transaction.h investtransaction.h stdtransaction.h
  transactionsortoption.h
  kmymoneyvalidationfeedback.h
  onlinejobmessagesview.h
  kmymoneydateedit.h
  amountedit.h amountvalidator.h creditdebithelper.h popuppositioner.h
  )

########### Shared widget library ###########
set(kmm_widgets_sources
  kmymoneydateinput.cpp
  kmymoneyvalidationfeedback.cpp
  styleditemdelegateforwarder.cpp
  kmymoneylineedit.cpp
  kmymoneytextedit.cpp
  kmymoneytextedithighlighter.cpp
  kmymoneymvccombo.cpp
  kmymoneygeneralcombo.cpp
  kmymoneyactivitycombo.cpp
  kmymoneycashflowcombo.cpp
  kmymoneyfrequencycombo.cpp
  kmymoneyoccurrencecombo.cpp
  kmymoneyoccurrenceperiodcombo.cpp
  kmymoneypayeecombo.cpp
  kmymoneyperiodcombo.cpp
  kmymoneyreconcilecombo.cpp
  kmymoneytagcombo.cpp
  kmymoneyaccountselector.cpp
  ktagcontainer.cpp
  ktaglabel.cpp
  kmymoneyselector.cpp
  kmymoneycalculator.cpp
  ktreewidgetfilterlinewidget.cpp
  kguiutils.cpp
  onlinejobmessagesview.cpp
  kmymoneydateedit.cpp
  kmymoneymoneyvalidator.cpp
  amountedit.cpp
  amountvalidator.cpp
  creditdebithelper.cpp
  daterangedlg.cpp
  ktransactionfilter.cpp
  kmymoneyaccounttreeview.cpp
  accountsviewproxymodel.cpp
  budgetviewproxymodel.cpp
  kmymoneyviewbase.cpp
  kmymoneyaccountsviewbase.cpp
  passwordtoggle.cpp
  popuppositioner.cpp
  )

set(nationalAccountWidget_SOURCES
  ./payeeidentifier/nationalaccount/nationalaccountedit.cpp
  ./payeeidentifier/nationalaccount/nationalaccountdelegate.cpp
)

set(nationalAccountWidget_HEADERS
  ./payeeidentifier/nationalaccount/nationalaccountdelegate.h
  ./payeeidentifier/nationalaccount/nationalaccountedit.h
)

set(IBANBICWidget_SOURCES
  ./payeeidentifier/ibanbic/kibanlineedit.cpp
  ./payeeidentifier/ibanbic/kbicedit.cpp
  ./payeeidentifier/ibanbic/ibanvalidator.cpp
  ./payeeidentifier/ibanbic/bicvalidator.cpp
  ./payeeidentifier/ibanbic/ibanbicitemdelegate.cpp
  ./payeeidentifier/ibanbic/ibanbicitemedit.cpp
)

set(IBANBICWidget_HEADERS
  ./payeeidentifier/ibanbic/kibanlineedit.h
  ./payeeidentifier/ibanbic/kbicedit.h
  ./payeeidentifier/ibanbic/ibanvalidator.h
  ./payeeidentifier/ibanbic/bicvalidator.h
  ./payeeidentifier/ibanbic/ibanbicitemdelegate.h
)

list(APPEND kmm_widgets_sources ${nationalAccountWidget_SOURCES})
list(APPEND kmymoney_STAT_HEADERS ${nationalAccountWidget_HEADERS})

list(APPEND kmm_widgets_sources ${IBANBICWidget_SOURCES})
list(APPEND kmymoney_STAT_HEADERS ${IBANBICWidget_HEADERS})

ki18n_wrap_ui(kmm_widgets_sources
  kmymoneyvalidationfeedback.ui
  onlinejobmessagesview.ui
  daterangedlg.ui
  ktransactionfilter.ui
  ./payeeidentifier/nationalaccount/nationalaccountedit.ui
  ./payeeidentifier/ibanbic/ibanbicitemedit.ui
)

add_library(kmm_widgets SHARED ${kmm_widgets_sources})
target_link_libraries(kmm_widgets PUBLIC
  kmm_settings
  KF5::TextWidgets
  KF5::KIOWidgets
  KF5::Completion
  KF5::Notifications
  KF5::ItemViews
  KF5::I18n
  Qt5::Gui
  Qt5::Core
  Alkimia::alkimia
  kmm_mymoney
  kmm_models
  kmm_plugin
)

set_target_properties(kmm_widgets PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
  COMPILE_FLAGS "-DKMM_BUILD_WIDGETS_LIB"
)

generate_export_header(kmm_widgets)

install(TARGETS kmm_widgets ${INSTALL_TARGETS_DEFAULT_ARGS} )

########### Basic Widget Library (kmymoney_base) STATIC #################

# Common sources for libkmymoney.so and libwidgets.a that do not
# contain the KMM_DESIGNER flag
set(_uncritial_common_sources
  kmymoneyaccountcombo.cpp
  kmymoneycombo.cpp
  kmymoneycompletion.cpp
  kmymoneytitlelabel.cpp
  kmymoneydateedit.cpp
  kpricetreeitem.cpp
  registeritem.cpp
  registerfilter.cpp
  scheduledtransaction.cpp
  selectedtransaction.cpp
  selectedtransactions.cpp
  stdtransactiondownloaded.cpp
  stdtransactionmatched.cpp
  transactionform.cpp
  tabbar.cpp
  transactionformitemdelegate.cpp
  transactionsortoption.cpp
  )

# sources that contain the KMM_DESIGNER flag
set (_critial_common_sources
  kaccounttemplateselector.cpp
  kmymoneycurrencyselector.cpp
  kmymoneyaccountcompletion.cpp
  kmymoneycategory.cpp
  groupmarker.cpp
  groupmarkers.cpp
  fancydategroupmarker.cpp
  fancydategroupmarkers.cpp
  register.cpp
  itemptrvector.cpp
  qwidgetcontainer.cpp
  registeritemdelegate.cpp
  transaction.cpp
  stdtransaction.cpp
  investtransaction.cpp
  transactioneditorcontainer.cpp
  )


set (kmymoney_base_UI
  transactionsortoption.ui kaccounttemplateselector.ui
  )

ki18n_wrap_ui(kmymoney_base_ui_srcs ${kmymoney_base_UI})
set(_uncritial_common_sources ${_uncritial_common_sources}
  ${kmymoney_base_ui_srcs})

# in order to use add_dependencies, we need to add this custom target
# for all generated header files.
# (see https://gitlab.kitware.com/cmake/community/wikis/FAQ#how-can-i-add-a-dependency-to-a-source-file-which-is-generated-in-a-subdirectory )
add_custom_target(generate_base_ui_srcs DEPENDS
  ${kmymoney_base_ui_srcs})

# We can compile the uncritical sources without KMM_DESIGNER flags
add_library(kmymoney_base STATIC ${_uncritial_common_sources})
# TODO: fix dependencies
target_link_libraries(kmymoney_base KF5::XmlGui KF5::TextWidgets KF5::IconThemes KF5::I18n KF5::ConfigWidgets KF5::ConfigCore KF5::Completion KF5::Service Qt5::Gui Qt5::Widgets Qt5::Xml kmm_settings Alkimia::alkimia)

add_dependencies(kmymoney_base kmm_settings)

########### QtDesigner Widget Library (kmymoneywidgets) #################
# we never link against this library,
# but it is needed for uic and QtDesigner
if( USE_QT_DESIGNER )
  set(kmymoneywidgets_PART_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/kmymoneywidgets.cpp)

  kde4_add_widget_files(kmymoneywidgets_PART_SRCS kmymoney.widgets)

  set(kmymoneywidgets_PART_SRCS
    ${_critial_common_sources}
    ${kmymoneywidgets_PART_SRCS})

  add_library(kmymoneywidgets MODULE ${kmymoneywidgets_PART_SRCS})

  include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

  # The option -DKMM_DESIGNER will leave away any code that breaks uic.
  set_target_properties(kmymoneywidgets PROPERTIES
    COMPILE_FLAGS "-DKMM_DESIGNER")

  # The qt-designer widget library shouldn't need to link against the
  # dialogs and converter libraries.  If a widget references something
  # from one of these libraries it is most likely due to code that needs
  # to be excluded with a KMM_DESIGNER ifndef.
  target_link_libraries(kmymoneywidgets kmymoney_base kmm_mymoney kmymoney_common kmm_settings models)

  install(TARGETS kmymoneywidgets DESTINATION ${QT_PLUGINS_DIR}/designer )
endif( USE_QT_DESIGNER )

########### Widget Library (widgets) STATIC #################

set(libwidgets_a_SOURCES
  ${_critial_common_sources}
  kmymoneybriefschedule.cpp
  registersearchline.cpp
  transactioneditorcontainer.cpp
  )

set(libwidgets_a_UI
  kmymoneybriefschedule.ui
  )

# using uic on the above UI files DEPENDS on libkmymoney.so. If uic
# does not find libkmymoney.so, gcc will fail compiling
# kmymoneyreportconfigtab2decl.cpp and throw errors like "invalid use
# of undefined type `struct KMyMoneyGeneralCombo'"


ki18n_wrap_ui(widgets_ui_srcs ${libwidgets_a_UI})
add_custom_target(generate_widgets_ui_srcs DEPENDS ${widgets_ui_srcs})

add_library(widgets STATIC
  ${libwidgets_a_SOURCES}
  ${widgets_ui_srcs}
  )
target_link_libraries(widgets KF5::XmlGui kmymoney_base)

add_dependencies(widgets kmm_settings)

########### install files ###############

install(FILES ${kmymoney_STAT_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/kmm_widgets_export.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney COMPONENT Devel)

############## tests ####################

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== kmymoney/converter/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
ecm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt5::Core
    Qt5::Test
    kmm_testutilities
    converter
)

=== kmymoney/mymoney/payeeidentifier/CMakeLists.txt ===
set ( PAYEEIDENTIFIER_HEADER
  payeeidentifier.h
  payeeidentifiertyped.h
  payeeidentifierdata.h
)

set ( PAYEEIDENTIFIER_SCRS
  payeeidentifier.cpp
)

add_library( kmm_payeeidentifier SHARED
  ${PAYEEIDENTIFIER_SCRS}
)

set_target_properties(kmm_payeeidentifier PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

generate_export_header( kmm_payeeidentifier )

target_link_libraries( kmm_payeeidentifier
  Qt5::Core
  Qt5::Xml
)

target_include_directories( kmm_payeeidentifier PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}
)

install( TARGETS kmm_payeeidentifier
  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== kmymoney/mymoney/tests/CMakeLists.txt ===
include(ECMAddTests)

add_library(kmm_testutils STATIC mymoneytestutils.cpp)
target_link_libraries(kmm_testutils
  PUBLIC
    Qt5::Core
    kmm_mymoney
)

file(GLOB tests_sources "*-test.cpp")
ecm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt5::Core
    Qt5::Test
    Qt5::Xml
    Qt5::Gui
    kmm_mymoney
    kmm_testutils
    kmm_testutilities
    onlinetask_interfaces
)

=== kmymoney/plugins/ofx/CMakeLists.txt ===
if(ENABLE_OFXIMPORTER AND LIBOFX_FOUND)
  add_subdirectory( import )
endif(ENABLE_OFXIMPORTER AND LIBOFX_FOUND)

=== kmymoney/wizards/newloanwizard/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

set (libnewloanwizard_a_SOURCES
  additionalfeeswizardpage.cpp       lendborrowwizardpage.cpp
  assetaccountwizardpage.cpp         loanamountwizardpage.cpp
  loanattributeswizardpage.cpp
  calculationoverviewwizardpage.cpp  namewizardpage.cpp
  durationwizardpage.cpp             newcalculateloanwizardpage.cpp
  editintrowizardpage.cpp            newgeneralinfowizardpage.cpp
  editselectionwizardpage.cpp        newintrowizardpage.cpp
  effectivedatewizardpage.cpp        newpaymentswizardpage.cpp
  finalpaymentwizardpage.cpp         paymenteditwizardpage.cpp
  firstpaymentwizardpage.cpp         paymentfrequencywizardpage.cpp
  interestcalculationwizardpage.cpp  paymentwizardpage.cpp
  interestcategorywizardpage.cpp     previouspaymentswizardpage.cpp
  interesteditwizardpage.cpp         recordpaymentwizardpage.cpp
  interesttypewizardpage.cpp         schedulewizardpage.cpp
  interestwizardpage.cpp             summaryeditwizardpage.cpp
  keditloanwizard.cpp                summarywizardpage.cpp
  knewloanwizard.cpp                 variableinterestdatewizardpage.cpp
  )

set (libnewloanwizard_a_UI
  knewloanwizard.ui
  additionalfeeswizardpage.ui       loanamountwizardpage.ui
  loanattributeswizardpage.ui
  assetaccountwizardpage.ui         namewizardpage.ui
  calculationoverviewwizardpage.ui  newcalculateloanwizardpage.ui
  durationwizardpage.ui             newgeneralinfowizardpage.ui
  editintrowizardpage.ui            newintrowizardpage.ui
  editselectionwizardpage.ui        newpaymentswizardpage.ui
  effectivedatewizardpage.ui        paymenteditwizardpage.ui
  finalpaymentwizardpage.ui         paymentfrequencywizardpage.ui
  firstpaymentwizardpage.ui         paymentwizardpage.ui
  interestcalculationwizardpage.ui  previouspaymentswizardpage.ui
  interestcategorywizardpage.ui     recordpaymentwizardpage.ui
  interesteditwizardpage.ui         schedulewizardpage.ui
  interesttypewizardpage.ui         summaryeditwizardpage.ui
  interestwizardpage.ui             summarywizardpage.ui
  knewloanwizard.ui                 variableinterestdatewizardpage.ui
  lendborrowwizardpage.ui
  )

ki18n_wrap_ui(libnewloanwizard_a_SOURCES ${libnewloanwizard_a_UI} )

add_library(newloanwizard STATIC ${libnewloanwizard_a_SOURCES})
# TODO: clean dependencies
target_link_libraries(newloanwizard newaccountwizard KF5::XmlGui KF5::IconThemes KF5::Service KF5::I18n KF5::Completion KF5::WidgetsAddons KF5::TextWidgets Qt5::Widgets Qt5::Xml Alkimia::alkimia)

# we rely on some dialogs to be generated
add_dependencies(newloanwizard dialogs)

=== kmymoney/wizards/newuserwizard/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

set (libnewuserwizard_a_SOURCES
  knewuserwizard.cpp
  kaccountpage.cpp
  kcategoriespage.cpp
  kcurrencypage.cpp
  kgeneralpage.cpp
  kintropage.cpp
  kpreferencepage.cpp
  )

set (libnewuserwizard_a_UI
  kaccountpage.ui kcurrencypage.ui
  kgeneralpage.ui
  kintropage.ui kpreferencepage.ui
  kpasswordpage.ui
  )

# The handling of these ui files depends
# on libkmymoney.so (the widgets library)
ki18n_wrap_ui(libnewuserwizard_a_SOURCES ${libnewuserwizard_a_UI})

add_library(newuserwizard STATIC ${libnewuserwizard_a_SOURCES})
# TODO: clean dependencies
target_link_libraries(newuserwizard kmymoneywizard KF5::ConfigGui KF5::KIOWidgets KF5::TextWidgets KF5::Completion KF5::ConfigWidgets Qt5::Widgets Qt5::Xml Alkimia::alkimia)
add_dependencies(newuserwizard widgets wizardpages)

=== kmymoney/plugins/sqlcipher/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
ecm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt5::Test
    Qt5::Sql
)

target_compile_definitions(qsqlcipher-test
  PRIVATE
  QSQLCIPHERPATH="${CMAKE_INSTALL_PREFIX}/${PLUGIN_INSTALL_DIR}")

# the test application is stored in CMAKE_RUNTIME_OUTPUT_DIRECTORY and
# the plugin is stored in CMAKE_LIBRARY_OUTPUT_DIRECTORY. On FreeBSD
# and Linux systems Qt expects the plugin to be found in various
# specific locations, where one is a sub-directory called sqldrivers
# in CMAKE_RUNTIME_OUTPUT_DIRECTORY. To achieve a running test, we
# simply create a symlink to CMAKE_LIBRARY_OUTPUT_DIRECTORY.

# Windows and MacOS may also need some adjustments, but I leave that
# to a developer under these system to make additions here
if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "Linux")
  if (NOT EXISTS "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/sqldrivers")
    FILE(MAKE_DIRECTORY
        ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        )
    EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink
        ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/sqldrivers
        )
  endif()
endif()

=== kmymoney/plugins/views/onlinejoboutbox/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/onlinejoboutboxview.json.cmake ${CMAKE_CURRENT_BINARY_DIR}/onlinejoboutboxview.json @ONLY)

set(onlinejoboutboxview_SOURCES
  onlinejoboutboxview.cpp
  konlinejoboutboxview.cpp
  konlinetransferform.cpp
  onlinejobmodel.cpp
  onlinejobmessagesmodel.cpp
  ${CMAKE_SOURCE_DIR}/kmymoney/widgets/kmymoneyaccountcombo.cpp
  )

ki18n_wrap_ui(onlinejoboutboxview_SOURCES
  konlinejoboutboxview.ui
  konlinetransferform.ui
  )

kcoreaddons_add_plugin(onlinejoboutboxview
                       SOURCES ${onlinejoboutboxview_SOURCES}
                       JSON "${CMAKE_CURRENT_BINARY_DIR}/onlinejoboutboxview.json"
                       INSTALL_NAMESPACE "kmymoney")

#kcoreaddons_add_plugin sets LIBRARY_OUTPUT_DIRECTORY to ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${INSTALL_NAMESPACE}
set_target_properties(onlinejoboutboxview
                      PROPERTIES
                      LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

target_link_libraries(onlinejoboutboxview
  PUBLIC
    kmm_plugin
    kmm_models
    kmm_widgets
    onlinetask_interfaces
    KF5::TextWidgets
    kmm_menus
)

=== kmymoney/plugins/weboob/interface/CMakeLists.txt ===
set(weboob_interface_SOURCES
    weboobinterface.cpp
    )

include_directories(${Python3_INCLUDE_DIRS})

qt5_add_resources(weboob_interface_SOURCES weboobinterface.qrc)

add_library(weboob_interface STATIC ${weboob_interface_SOURCES})
target_link_libraries (
  weboob_interface
  PUBLIC
  Qt5::Core
  Alkimia::alkimia
  PRIVATE
  ${Python3_LIBRARIES}
  )

=== debian/changelog ===
kmymoney (5.1.2-4) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Add patch to fix build failures against KDEPIM 21.12.

 -- Patrick Franz <deltaone@debian.org>  Sat, 02 Apr 2022 13:21:42 +0200

kmymoney (5.1.2-3) unstable; urgency=medium

  * Team upload.
  * Bump the libical-dev build dependency to 3.0.11-2, as it finally ships the
    CMake config files, required by upstream
    - drop cmake-libical-own-module.diff, no more needed now
  * CI: enable again the blhc job.

 -- Pino Toscano <pino@debian.org>  Thu, 28 Oct 2021 08:37:38 +0200

kmymoney (5.1.2-2) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit 125db90e64d77657918335df85f4c45b0d04325d, and
    commit 265d4dc3d1dc8592ec1122aa04bfb7d431a43d5d to build with newer versions
    of Gwenhywfar; patches upstream_Remove-unused-variable-definition.patch and
    upstream_Fix-build-with-newer-Gwenhywfar-versions.patch. (Closes: #995676)
  * CI: disable the blhc job.

 -- Pino Toscano <pino@debian.org>  Tue, 12 Oct 2021 07:54:48 +0200

kmymoney (5.1.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.12.0
  * Bump Standards-Version to 4.6.0, no changes required.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Temporarily switch the CMake detection of libical to the own code, instead
    of relying on the CMake config module of libical which is not shipped in
    libical-dev (I do not know why); patch +cmake-libical-own-module.diff.
  * Update install files.
  * Stop shipping README.Fileformats, as it does not exist anymore (moved as
    online documentation).

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 14:18:28 +0200

=== debian/control ===
Source: kmymoney
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.12.0~),
 pkg-kde-tools (>= 0.15.16),
 gettext,
 extra-cmake-modules (>= 5.42.0~),
 qtbase5-dev (>= 5.2.0~),
 qtbase5-private-dev (>= 5.2.0~),
 qtdeclarative5-dev (>= 5.2.0~),
 libqt5svg5-dev (>= 5.2.0~),
 libkf5activities-dev (>= 5.2.0~),
 libkf5akonadi-dev,
 libkf5archive-dev (>= 5.2.0~),
 libkf5completion-dev (>= 5.2.0~),
 libkf5config-dev (>= 5.2.0~),
 libkf5configwidgets-dev (>= 5.2.0~),
 libkf5contacts-dev,
 libkf5coreaddons-dev (>= 5.2.0~),
 libkf5doctools-dev (>= 5.2.0~),
 libkf5holidays-dev,
 libkf5i18n-dev (>= 5.2.0~),
 libkf5iconthemes-dev (>= 5.2.0~),
 libkf5identitymanagement-dev,
 libkf5itemmodels-dev (>= 5.2.0~),
 libkf5itemviews-dev (>= 5.2.0~),
 libkchart-dev,
 libkf5kcmutils-dev (>= 5.2.0~),
 libkf5kio-dev (>= 5.2.0~),
 libkf5notifications-dev (>= 5.2.0~),
 libkf5service-dev (>= 5.2.0~),
 libkf5textwidgets-dev (>= 5.2.0~),
 libkf5wallet-dev (>= 5.2.0~),
 libkf5webkit-dev (>= 5.2.0~),
 libkf5xmlgui-dev (>= 5.2.0~),
 libaqbanking-dev (>= 6.0.1~),
 libgwenhywfar-core-dev (>= 5.1.2~), libgwengui-qt5-dev (>= 5.1.2~),
 libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
 libalkimia5-dev (>= 7.0),
 libical-dev (>= 3.0.11-2~),
 libofx-dev, libgmp-dev,
 libsqlcipher-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://kmymoney.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git

Package: kmymoney
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kmymoney-common (= ${source:Version})
Recommends: gnupg-agent, pinentry-qt | pinentry-x11
Suggests: kcalc
Description: personal finance manager for KDE
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.

Package: kmymoney-common
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
Recommends: kmymoney,
 libfinance-quote-perl,
Description: KMyMoney architecture independent files
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.
 .
 This package contains architecture independent files needed for KMyMoney to
 run properly. It also provides KMyMoney documentation. Therefore, unless you
 have 'kmymoney' package installed, you will hardly find this package useful.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DCMAKE_SKIP_RPATH=ON -DBUILD_TESTING=OFF

execute_after_dh_auto_install:
	# remove development stuff
	rm -rf debian/tmp/usr/include/
	find debian/tmp -name '*.so' -type l -delete

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://download.kde.org/stable/kmymoney/([\d\.]+)/src/kmymoney-([\d\.]+)\.tar\.xz
